<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Submodulo</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas gestionar, editar o crear un Submodulo?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-sheet class="overflow-y-auto CardScroll">
        <draggable
          v-model="modulos"
          v-bind="{ group: 'people', draggable: '.item' }"
          style="min-height: 10px"
          class="row"
        >
          <template v-for="(modulo, indexModulo) in modulos">
            <v-col
              class="item"
              :key="indexModulo"
              :xs="12"
              :sm="12"
              :md="6"
              :lg="3"
            >
              <div>
                <v-card class="generalCard pa-4">
                  <div>
                    <v-btn
                      x-small
                      class="float-left"
                      text
                      icon
                      @click="(dialogDelete = true), (modulo_delete = modulo)"
                    >
                      <v-img
                        :contain="true"
                        :aspect-ratio="1"
                        position="center"
                        src="@/assets/img/delete.svg"
                        class="white--text align-end"
                      ></v-img>
                    </v-btn>
                    <v-btn
                      :to="modulo.to"
                      x-small
                      class="float-right"
                      text
                      icon
                    >
                      <v-img
                        :contain="true"
                        :aspect-ratio="1"
                        position="center"
                        src="@/assets/img/icoEditar.svg"
                        class="white--text align-end"
                      ></v-img>
                    </v-btn>
                  </div>
                  <v-card-text>
                    <div class="cardFranqName cardFranqNameLine">
                      {{ modulo.descripcion }}
                    </div>
                    <div class="cardCreacion">
                      <div>
                        Fecha de creación:
                        {{ moment(modulo.fecha_creacion).format("DD/MM/YYYY") }}
                      </div>
                    </div>
                    <v-footer absolute class="CardCustomAction">
                      <v-col>
                        <v-btn
                          class="ma-2"
                          dark
                          tile
                          :to="modulo.to_submodulos"
                          depressed
                          color="primary"
                          >Gestionar Submodulos</v-btn
                        >
                      </v-col>
                    </v-footer>
                  </v-card-text>
                </v-card>
              </div>
            </v-col>
          </template>
        </draggable>
      </v-sheet>
      <v-divider />
      <v-row>
        <v-col :key="cardAddSubModulo.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardAddSubModulo.to"
            :color="cardAddSubModulo.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAddSubModulo.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAddSubModulo.src"
                :lazy-src="cardAddSubModulo.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
      </v-row>
      <template>
        <v-dialog v-model="dialogDelete" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                <strong>¿Seguro que deseas eliminar este modulo?</strong>
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogDelete = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  :class="[{ desac: deletingModulo }]"
                  @click="deleteModulo()"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
    </div>
  </div>
</template>
<script>
import axios from "axios";
import store from "@/store";
import draggable from "vuedraggable";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
import moment from "moment";
export default {
  name: "Component-SubModulos",
  components: {
    draggable
  },
  data() {
    return {
      moment: moment,
      modulo_delete: null,
      dialogDelete: false,
      flujo: null,
      modulo: null,
      deletingModulo: false,
      route: null,
      cardAddSubModulo: {
        title: "Crear Submodulo",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade una nuevo modulo a la lista.",
        to: {
          name: "privilegios_flujos_modulos_submodulos_nuevo"
        },
        color: "#494949"
      },
      breadcrumbs: [],
      breadcrumbsBase: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios"
          }
        },
        {
          text: "Flujos",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_flujos"
          }
        }
      ],
      modulos: []
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    getTreeModulo() {
      var self = this;
      axios
        .get(
          "/modulo/flujo/secure/get/flujo/tree/asc/" +
            this.modulo.id_flujo_modulo
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                let breadcrumbsDinamic = [];
                const length = data.length;
                data.forEach((item, indexItem) => {
                  item.id_parent = item.id_flujo_modulo;
                  item.descripcion = serviceCommons.titleCase(item.descripcion);
                  if (length - 1 == indexItem) {
                    breadcrumbsDinamic.push({
                      text: item.descripcion,
                      disabled: true
                    });
                  } else {
                    breadcrumbsDinamic.push({
                      text: item.descripcion,
                      disabled: false,
                      exact: true,
                      to: {
                        name: "privilegios_flujos_modulos_submodulos",
                        params: {
                          flujo: this.serviceCommons.objectToBase64(self.flujo),
                          modulo: self.serviceCommons.objectToBase64(item)
                        }
                      }
                    });
                  }
                });
                let breadcrumbsTemp = JSON.parse(
                  JSON.stringify(self.getBreadcrumbsBase())
                );
                breadcrumbsDinamic.forEach((item) => {
                  breadcrumbsTemp.push(item);
                });
                self.breadcrumbs = breadcrumbsTemp;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    getModulos() {
      var self = this;
      let filter = {
        id_flujo: this.flujo.id_flujo,
        id_parent: this.modulo.id_parent
      };
      axios
        .post("/modulo/flujo/secure/get/flujo/parent", filter)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setModulos(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setModulos(data) {
      if (data) {
        data.forEach((itemModulo) => {
          itemModulo.to = {
            name: "privilegios_flujos_modulos_submodulos_edicion",
            params: {
              modulo: this.serviceCommons.objectToBase64(this.modulo),
              sub_modulo: this.serviceCommons.objectToBase64(itemModulo),
              flujo: this.serviceCommons.objectToBase64(this.flujo)
            }
          };
          itemModulo.id_parent = itemModulo.id_flujo_modulo;
          itemModulo.to_submodulos = {
            name: "privilegios_flujos_modulos_submodulos",
            params: {
              modulo: this.serviceCommons.objectToBase64(itemModulo),
              flujo: this.serviceCommons.objectToBase64(this.flujo)
            }
          };
        });
        this.modulos = data;
      }
    },
    deleteModulo() {
      var self = this;
      self.modulo_delete.id_empleado_modifica = user.empleado;
      axios
        .delete("/modulo/flujo/secure/delete", { data: self.modulo_delete })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              self.dialogDelete = false;
              self.getModulos();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.deletingModulo = false;
        });
    },
    getBreadcrumbsBase() {
      let breadcrumbsBaseTemp = JSON.parse(
        JSON.stringify(this.breadcrumbsBase)
      );
      breadcrumbsBaseTemp.push({
        text: this.flujo.descripcion,
        disabled: true
      });
      breadcrumbsBaseTemp.push({
        text: "Modulos",
        disabled: false,
        exact: true,
        to: {
          name: "privilegios_flujos_modulos",
          params: {
            flujo: this.serviceCommons.objectToBase64(this.flujo)
          }
        }
      });
      return breadcrumbsBaseTemp;
    },
    initValues() {
      this.cardAddSubModulo.to.params = {
        flujo: this.serviceCommons.objectToBase64(this.flujo),
        modulo: this.serviceCommons.objectToBase64(this.modulo)
      };
      this.breadcrumbs = JSON.parse(JSON.stringify(this.getBreadcrumbsBase()));
      this.getTreeModulo();
    },
    onCreated() {
      if (this.$route.params.flujo) {
        this.flujo = this.serviceCommons.base64ToObject(
          this.$route.params.flujo
        );
      }
      if (this.$route.params.modulo) {
        this.modulo = this.serviceCommons.base64ToObject(
          this.$route.params.modulo
        );
      }
      this.initValues();
      this.getModulos();
    }
  },
  created() {
    this.onCreated();
  },
  beforeRouteUpdate(to, from, next) {
    next();
    this.route = to;
    this.onCreated();
  }
};
</script>
